import { RPCMessage } from '../core/type';

export interface Codec {
  encode(message: string): RPCMessage;
  decode(message: RPCMessage): string;
}

export class DefaultCodec implements Codec {
  public encode(message: string): RPCMessage {
    return message;
  }
  public decode(message: RPCMessage): string {
    return <string>message;
  }
}

export const defaultCodec = new DefaultCodec();

export interface CodecSelector {
  encode(message: string): RPCMessage;
  decode(message: RPCMessage): string;
}

export class DefaultCodecSelector implements CodecSelector {
  public encode(message: string): RPCMessage {
    return defaultCodec.encode(message);
  }
  public decode(message: RPCMessage): string {
    return defaultCodec.decode(message);
  }
}

export const defaultCodecSelector = new DefaultCodecSelector();
